﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GridTester
{
    public class Product : INotifyPropertyChanged
    {
        public Product()
        {
        }

        private string sku;
        public string SKU
        {
            get
            {
                return this.sku;
            }
            set
            {
                if (this.sku != value)
                {
                    this.sku = value;
                    this.OnPropertyChanged("SKU");
                }
            }
        }

        private string name;
        public string Name
        {
            get
            {
                return this.name;
            }
            set
            {
                if (this.name != value)
                {
                    this.name = value;
                    this.OnPropertyChanged("Name");
                }

            }
        }

        private string category;
        public string Category
        {
            get
            {
                return this.category;
            }
            set
            {
                if (this.category != value)
                {
                    this.category = value;
                    this.OnPropertyChanged("Category");
                }

            }
        }

        private string designer;
        public string Designer
        {
            get
            {
                return this.designer;
            }
            set
            {
                if (this.designer != value)
                {
                    this.designer = value;
                    this.OnPropertyChanged("Designer");
                }
            }
        }

        private string imageUrl;
        public string ImageUrl
        {
            get
            {
                return this.imageUrl;
            }
            set
            {
                if (this.imageUrl != value)
                {
                    this.imageUrl = value;
                    this.OnPropertyChanged("ImageUrl");
                }

            }
        }

        private bool inStock;
        public bool InStock
        {
            get
            {
                return this.inStock;
            }
            set
            {
                if (this.inStock != value)
                {
                    this.inStock = value;
                    this.OnPropertyChanged("InStock");
                }
            }
        }

        private bool onBackOrder;
        public bool OnBackOrder
        {
            get
            {
                return this.onBackOrder;
            }
            set
            {
                if (this.onBackOrder != value)
                {
                    this.onBackOrder = value;
                    this.OnPropertyChanged("OnBackOrder");
                }
            }
        }

        private string supplier;
        public string Supplier
        {
            get
            {
                return this.supplier;
            }
            set
            {
                if (this.supplier != value)
                {
                    this.supplier = value;
                    this.OnPropertyChanged("Supplier");
                }
            }
        }

        private decimal unitPrice;
        public decimal UnitPrice
        {
            get
            {
                return this.unitPrice;
            }
            set
            {
                if (this.unitPrice != value)
                {
                    this.unitPrice = value;
                    this.OnPropertyChanged("UnitPrice");
                }
            }
        }

        private int unitsInStock;
        public int UnitsInStock
        {
            get
            {
                return this.unitsInStock;
            }
            set
            {
                if (this.unitsInStock != value)
                {
                    this.unitsInStock = value;
                    this.OnPropertyChanged("UnitsInStock");
                }
            }
        }

        private int unitsOnOrder;
        public int UnitsOnOrder
        {
            get
            {
                return this.unitsOnOrder;
            }
            set
            {
                if (this.unitsOnOrder != value)
                {
                    this.unitsOnOrder = value;
                    this.OnPropertyChanged("UnitsOnOrder");
                }
            }
        }
        private string quantityPerUnit;
        public string QuantityPerUnit
        {
            get
            {
                return this.quantityPerUnit;
            }
            set
            {
                if (this.quantityPerUnit != value)
                {
                    this.quantityPerUnit = value;
                    this.OnPropertyChanged("QuantityPerUnit");
                }
            }
        }

        private Uri productUri;
        public Uri ProductUri
        {
            get
            {
                return this.productUri;
            }
            set
            {
                this.productUri = value;
                this.OnPropertyChanged("ProductUri");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
                handler(this, new PropertyChangedEventArgs(propertyName));

        }
    }

}
